



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Asp.net MVC]Asp.net MVC5系列——实现编辑、删除与明细信息视图</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Asp.net MVC]Asp.net MVC5系列——实现编辑、删除与明细信息视图</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 15:34:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>目录</h3>
<p><strong><a href="#t1" rel="external nofollow noreferrer">概述</a></strong></p>
<p><strong><a href="#t4" rel="external nofollow noreferrer">实现信息的明细视图</a></strong></p>
<p><strong><a href="#t2" rel="external nofollow noreferrer">实现信息的编辑视图</a></strong></p>
<p><strong><a href="#t3" rel="external nofollow noreferrer">实现信息的删除视图</a></strong></p>
<p><strong><a href="#t5" rel="external nofollow noreferrer">总结</a></strong></p>
<h3>系列文章</h3>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6158492.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;第一个项目</a></p>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6158915.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;添加视图</a></p>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6158904.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;添加模型</a></p>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6159550.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;从控制器访问模型中的数据</a></p>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6170484.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;添加数据</a></p>
<p><a href="http://www.cnblogs.com/hehehehehe/p/6174574.html" rel="external nofollow noreferrer">[Asp.net MVC]Asp.net MVC5系列&mdash;&mdash;在模型中添加验证规则</a></p>
<h3>概述</h3>
<p>上篇文章介绍了，在提交表单时对数据的验证规则，在提交的数据合法时，将数据添加到数据库，也就是实现了信息的增加视图。这篇文章将实现查看明细，编辑，删除视图。</p>
<h3>实现信息的明细视图</h3>
<p>首先，让我们来看一下如何实现一条数据的明细信息视图。为了更好地体会这一功能，首先我们在前文所述的学生信息列表视图（Views文件夹下面的Student文件夹下面的StudentList.cshtml文件）中保留学生信息的姓名、性别、地址、电话、班级等字段。修改后的学生列表视图代码：</p>
<div>
<pre class="prettyprint linenums"> 1 @model IEnumerable&lt;Wolfy.FirstMVCProject.Models.Student&gt;<br />
 2<br />
 3 @{<br />
 4     Layout = null;<br />
 5 }<br />
 6<br />
 7 &lt;!DOCTYPE html&gt;<br />
 8<br />
 9 &lt;html&gt;<br />
10 &lt;head&gt;<br />
11     &lt;meta name="viewport" content="width=device-width" /&gt;<br />
12     &lt;title&gt;学生信息&lt;/title&gt;<br />
13 &lt;/head&gt;<br />
14 &lt;body&gt;<br />
15     &lt;p&gt;<br />
16         @Html.ActionLink("添加", "Create")<br />
17     &lt;/p&gt;<br />
18     &lt;table class="table"&gt;<br />
19         &lt;tr&gt;<br />
20             &lt;th&gt;<br />
21                姓名<br />
22             &lt;/th&gt;<br />
23             &lt;th&gt;<br />
24               性别<br />
25             &lt;/th&gt;<br />
26             &lt;th&gt;<br />
27                地址<br />
28             &lt;/th&gt;<br />
29<br />
30             &lt;th&gt;<br />
31                电话<br />
32             &lt;/th&gt;<br />
33             &lt;th&gt;<br />
34                删除<br />
35             &lt;/th&gt;<br />
36<br />
37             &lt;th&gt;<br />
38                班级名称<br />
39             &lt;/th&gt;<br />
40             &lt;th&gt;&lt;/th&gt;<br />
41         &lt;/tr&gt;<br />
42<br />
43     @foreach (var item in Model) {<br />
44         &lt;tr&gt;<br />
45             &lt;td&gt;<br />
46                 @Html.DisplayFor(modelItem =&gt; item.stuName)<br />
47             &lt;/td&gt;<br />
48             &lt;td&gt;<br />
49                 @Html.DisplayFor(modelItem =&gt; item.stuSex)<br />
50             &lt;/td&gt;<br />
51             &lt;td&gt;<br />
52                 @Html.DisplayFor(modelItem =&gt; item.stuAddress)<br />
53             &lt;/td&gt;<br />
54             &lt;td&gt;<br />
55                 @Html.DisplayFor(modelItem =&gt; item.stuPhone)<br />
56             &lt;/td&gt;<br />
57             &lt;td&gt;<br />
58                 @Html.DisplayFor(modelItem =&gt; item.Course.className)<br />
59             &lt;/td&gt;<br />
60             &lt;td&gt;<br />
61                 @Html.ActionLink("编辑", "Edit", new { id=item.stuId }) |<br />
62                 @Html.ActionLink("详细", "Details", new { id=item.stuId }) |<br />
63                 @Html.ActionLink("删除", "Delete", new { id=item.stuId })<br />
64             &lt;/td&gt;<br />
65<br />
66         &lt;/tr&gt;<br />
67     }<br />
68<br />
69     &lt;/table&gt;<br />
70 &lt;/body&gt;<br />
71 &lt;/html&gt;</pre>
</div>
<p>右键在浏览器中查看<br /><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/091603077721693.x-png" /></p>
<p>现在学生列表中就只显示每条数据的姓名、性别、地址、电话、班级名称了，如果想查看该条数据的详细信息，需要点击每条数据的&ldquo;详细&rdquo;链接，将画面导航到明细数据画面，在该画面中查看这条数据的明细信息。当一条数据的细节信息比较多，而我们只想在该数据的列举清单中显示该数据的几个摘要信息，通过点击链接或按钮的操作来查看数据的细节信息时这种处理方法是比较有用的。</p>
<p>接下来让我们来追加这个明细数据视图。首先打开Student控制器，追加一个返回明细数据视图的Details方法，代码如下所示复制代码&nbsp;         /// &lt;summary&gt;&nbsp;         /// 学生信息详细Acti<em><em><em>&nbsp;         /// &lt;/summary&gt;</em></em></em></p>
<div>
<pre class="prettyprint linenums"><em><em><em><em>          /// &lt;param name="id"&gt;&lt;/param&gt;<br />
          /// &lt;returns&gt;&lt;/returns&gt;<br />
          public ActionResult Details(int id)<br />
          {<br />
              var student = from s in entity.Student<br />
                            where s.stuId == id<br />
                           select s;

</em></em></em></em><em>&nbsp;                    //Find方法和FirstOrDefault方法效果相同，</em><em><em>都是返回满足条件的第一个元素，如果没有该元素，则返回null。</em></em></pre>
<pre class="prettyprint linenums"><em><em><em><em><em>             Student stu = student.FirstOrDefault();<br />
             //查到了该学生的详细<br />
             if (stu != null)<br />
             {<br />
                 //找到该学生的信息，则在Details视图中显示，将该学生的信息对象传过去。<br />
                 return View("Details",stu);<br />
             }<br />
             else<br />
             {<br />
                 //没有查到学生信息明细，则返回学生列表<br />
                 return RedirectToAction("StudentList");<br />
             }

         }</em></em></em></em></em></pre>
</div>
<p>在Details方法中点击鼠标右键，选择&ldquo;添加视图&rdquo;，模型类选择Student,在支架模板中选择&ldquo;Details&rdquo;（明细数据），如图所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/091617084902703.x-png" /></p>
<p>如果要创建中文网站或应用程序，则将默认生成的Details.cshtml文件中有关英文文字修改为中文，修改完毕后该文件中的代码如下所示。</p>
<div>
<pre class="prettyprint linenums">  1 @model Wolfy.FirstMVCProject.Models.Student<br />
  2<br />
  3 @{<br />
  4     Layout = null;<br />
  5 }<br />
  6<br />
  7 &lt;!DOCTYPE html&gt;<br />
  8<br />
  9 &lt;html&gt;<br />
 10 &lt;head&gt;<br />
 11     &lt;meta name="viewport" content="width=device-width" /&gt;<br />
 12     &lt;title&gt;Details&lt;/title&gt;<br />
 13 &lt;/head&gt;<br />
 14 &lt;body&gt;<br />
 15     &lt;div&gt;<br />
 16         &lt;h4&gt;Student&lt;/h4&gt;<br />
 17         &lt;hr /&gt;<br />
 18         &lt;dl class="dl-horizontal"&gt;<br />
 19             &lt;dt&gt;<br />
 20                 姓名<br />
 21             &lt;/dt&gt;<br />
 22<br />
 23             &lt;dd&gt;<br />
 24                 @Html.DisplayFor(model =&gt; model.stuName)<br />
 25             &lt;/dd&gt;<br />
 26<br />
 27             &lt;dt&gt;<br />
 28               性别<br />
 29             &lt;/dt&gt;<br />
 30<br />
 31             &lt;dd&gt;<br />
 32                 @Html.DisplayFor(model =&gt; model.stuSex)<br />
 33             &lt;/dd&gt;<br />
 34<br />
 35             &lt;dt&gt;<br />
 36               生日<br />
 37             &lt;/dt&gt;<br />
 38<br />
 39             &lt;dd&gt;<br />
 40                 @Html.DisplayFor(model =&gt; model.stuBirthdate)<br />
 41             &lt;/dd&gt;<br />
 42<br />
 43             &lt;dt&gt;<br />
 44                 入学时间<br />
 45             &lt;/dt&gt;<br />
 46<br />
 47             &lt;dd&gt;<br />
 48                 @Html.DisplayFor(model =&gt; model.stuStudydate)<br />
 49             &lt;/dd&gt;<br />
 50<br />
 51             &lt;dt&gt;<br />
 52                 地址<br />
 53             &lt;/dt&gt;<br />
 54<br />
 55             &lt;dd&gt;<br />
 56                 @Html.DisplayFor(model =&gt; model.stuAddress)<br />
 57             &lt;/dd&gt;<br />
 58<br />
 59             &lt;dt&gt;<br />
 60               邮箱<br />
 61             &lt;/dt&gt;<br />
 62<br />
 63             &lt;dd&gt;<br />
 64                 @Html.DisplayFor(model =&gt; model.stuEmail)<br />
 65             &lt;/dd&gt;<br />
 66<br />
 67             &lt;dt&gt;<br />
 68               电话<br />
 69             &lt;/dt&gt;<br />
 70<br />
 71             &lt;dd&gt;<br />
 72                 @Html.DisplayFor(model =&gt; model.stuPhone)<br />
 73             &lt;/dd&gt;<br />
 74<br />
 75             &lt;dt&gt;<br />
 76                是否删除<br />
 77             &lt;/dt&gt;<br />
 78<br />
 79             &lt;dd&gt;<br />
 80                 @Html.DisplayFor(model =&gt; model.stuIsDel)<br />
 81             &lt;/dd&gt;<br />
 82<br />
 83             &lt;dt&gt;<br />
 84                录入时间<br />
 85             &lt;/dt&gt;<br />
 86<br />
 87             &lt;dd&gt;<br />
 88                 @Html.DisplayFor(model =&gt; model.stuInputtime )<br />
 89             &lt;/dd&gt;<br />
 90<br />
 91             &lt;dt&gt;<br />
 92                班级<br />
 93             &lt;/dt&gt;<br />
 94<br />
 95             &lt;dd&gt;<br />
 96                 @Html.DisplayFor(model =&gt; model.Course.className)<br />
 97             &lt;/dd&gt;<br />
 98<br />
 99         &lt;/dl&gt;<br />
100     &lt;/div&gt;<br />
101     &lt;p&gt;<br />
102         @Html.ActionLink("Edit", "Edit", new { id = Model.stuId }) |<br />
103         @Html.ActionLink("Back to List", "StudentList")<br />
104     &lt;/p&gt;<br />
105 &lt;/body&gt;<br />
106 &lt;/html&gt;</pre>
</div>
<p>重新运行应用程序，在学生信息列表中点击某个学生的&ldquo;详细&rdquo;链接</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/091629240539822.x-png" /></p>
<p>通过观察地址栏你会发现：<a href="http://localhost:4585/Student/Details/9" rel="external nofollow noreferrer">http://localhost:4585/Student/Details/9</a>，在url中最后一个9就是学生的id，这个参数是如何传递的呢？</p>
<p>在学生列表视图代码中你会发现类似如下的代码：</p>
<div>
<pre class="prettyprint linenums"> @Html.ActionLink("详细", "Details", new { id=item.stuId }) </pre>
</div>
<p>其中id为url中参数的名称，然后我们看一下action方法中的参数也为id，这两者是否必须对应呢？那么，我们修改一下Details方法中的参数名称，测试一下。</p>
<p>将Details方法的参数名改为intI的，然后运行，则会出现如下的信息。<br /><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/091637544438215.x-png" /></p>
<p><strong>可见，视图中传递的参数名和Action中的参数名必须一样。</strong></p>
<h3>实现信息的编辑视图</h3>
<p>接下来，让我们来看一下如何实现一个用来修改数据的视图。</p>
<p>首先打开Student控制器，追加一个返回数据修改视图的Edit方法与一个对该视图中的表单提交进行处理的Edit方法，代码如下所示。</p>
<div>
<pre class="prettyprint linenums">          public ActionResult Edit(int id)<br />
          {<br />
              var student = from s in entity.Student<br />
                            where s.stuId == id<br />
                            select s;<br />
              Student stu = student.FirstOrDefault();

              //查到了该学生的详细<br />
              if (stu != null)<br />
             {<br />
                 //外键关系处理<br />
                 var course = from c in entity.Course<br />
                              where c.classId == stu.classId<br />
                              select c;<br />
                 stu.Course = course.FirstOrDefault();<br />
                 //因为学生信息中有班级id的外键，所以在编辑的时候，要指定dropdownlist的数据源<br />
                 var courses = from s in entity.Course<br />
                               select s;

                 List&lt;SelectListItem&gt; items = new List&lt;SelectListItem&gt;();<br />
                 foreach (var item in courses)<br />
                 {<br />
                     SelectListItem selectListItem = null;<br />
                     //当前学生所在的班级被选中<br />
                     if (item.classId == stu.classId)<br />
                     {<br />
                         selectListItem = new SelectListItem() { Text = item.className, Value = item.classId.ToString(), Selected = true };<br />
                     }<br />
                     else<br />
                     {<br />
                         selectListItem = new SelectListItem() { Text = item.className, Value = item.classId.ToString() };<br />
                     }

                     items.Add(selectListItem);<br />
                 }<br />
                 ViewData["course"] = items;<br />
                 //找到该学生的信息，则在Details视图中显示，将该学生的信息对象传过去。<br />
                 return View("Edit", stu);<br />
             }<br />
             else<br />
             {<br />
                 //没有查到学生信息明细，则返回学生列表<br />
                 return RedirectToAction("StudentList");<br />
             }<br />
         }<br />
         /// &lt;summary&gt;<br />
         /// 处理post请求的action方法，也就是修改后提交的数据<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="id"&gt;&lt;/param&gt;<br />
         /// &lt;returns&gt;&lt;/returns&gt;<br />
         [HttpPost]<br />
         public ActionResult Edit(Student student)<br />
         {<br />
             try<br />
             {<br />
                 var stu = entity.Student.Find(student.stuId);<br />
                 //处理学生所在的班级<br />
                 string strCourseId = Request.Form["course"];<br />
                 //作为测试，我们只修改性别和班级<br />
                 stu.stuSex = student.stuSex;<br />
                 stu.classId = Convert.ToInt32(strCourseId);<br />
                 entity.Entry&lt;Student&gt;(stu).State = System.Data.Entity.EntityState.Modified;

                 int intCount = entity.SaveChanges();<br />
                 if (intCount &gt; )<br />
                 {<br />
                     return RedirectToAction("Details", new { id = student.stuId });<br />
                 }<br />
                 else<br />
                 {<br />
                     return Content("修改失败");<br />
                 }<br />
             }<br />
             catch (Exception)<br />
             {

                 return Content("修改失败");<br />
             }<br />
         }</pre>
</div>
<p>这两个Edit方法中，第一个方法将在用户点击外部画面的&ldquo;编辑&rdquo;链接时被调用,用来在浏览器中显示数据修改视图，并且在该视图中显示用户选择编辑的数据。第二个Edit方法前面带有一个[HttpPost]标记，负责将修改数据视图中提交的表单数据绑定到一个用模型创建出来的Student对象实例之上（当用户在表单中完成数据修改并点击保存按钮的时候进行提交），在保存数据的过程中如果发生任何错误而导致保存失败的话，则提示修改失败文字信息。</p>
<p>（<strong>作为测试用，我们只修改性别和班级的信息</strong>）</p>
<p>接下来让我们来追加该数据修改视图、在Edit方法中点击鼠标右键，选择&ldquo;添加视图&rdquo;，模型类选择Student,在支架模板中选择&ldquo;Edit&rdquo;（修改数据），如图所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/092052004591926.x-png" /></p>
<p>如果要创建中文网站或应用程序，则将默认生成的Edit.cshtml文件代码如下所示。</p>
<div>
<pre class="prettyprint linenums">  1 @model Wolfy.FirstMVCProject.Models.Student<br />
  2<br />
  3 @{<br />
  4     Layout = null;<br />
  5 }<br />
  6<br />
  7 &lt;!DOCTYPE html&gt;<br />
  8<br />
  9 &lt;html&gt;<br />
 10 &lt;head&gt;<br />
 11     &lt;meta name="viewport" content="width=device-width" /&gt;<br />
 12     &lt;title&gt;Edit&lt;/title&gt;<br />
 13 &lt;/head&gt;<br />
 14 &lt;body&gt;<br />
 15     @using (Html.BeginForm("Edit","Student",FormMethod.Post))<br />
 16     {<br />
 17         @Html.AntiForgeryToken()<br />
 18<br />
 19         &lt;div class="form-horizontal"&gt;<br />
 20             &lt;h4&gt;Student&lt;/h4&gt;<br />
 21             &lt;hr /&gt;<br />
 22             @Html.ValidationSummary(true)<br />
 23             @Html.HiddenFor(model =&gt; model.stuId)<br />
 24<br />
 25             &lt;div class="form-group"&gt;<br />
 26                 @Html.LabelFor(model =&gt; model.stuName, new { @class = "control-label col-md-2" })<br />
 27                 &lt;div class="col-md-10"&gt;<br />
 28                     @Html.EditorFor(model =&gt; model.stuName)<br />
 29                     @Html.ValidationMessageFor(model =&gt; model.stuName)<br />
 30                 &lt;/div&gt;<br />
 31             &lt;/div&gt;<br />
 32<br />
 33             &lt;div class="form-group"&gt;<br />
 34                 @Html.LabelFor(model =&gt; model.stuSex, new { @class = "control-label col-md-2" })<br />
 35                 &lt;div class="col-md-10"&gt;<br />
 36                     @Html.EditorFor(model =&gt; model.stuSex)<br />
 37                     @Html.ValidationMessageFor(model =&gt; model.stuSex)<br />
 38                 &lt;/div&gt;<br />
 39             &lt;/div&gt;<br />
 40<br />
 41             &lt;div class="form-group"&gt;<br />
 42                 @Html.LabelFor(model =&gt; model.stuBirthdate, new { @class = "control-label col-md-2" })<br />
 43                 &lt;div class="col-md-10"&gt;<br />
 44                     @Html.EditorFor(model =&gt; model.stuBirthdate)<br />
 45                     @Html.ValidationMessageFor(model =&gt; model.stuBirthdate)<br />
 46                 &lt;/div&gt;<br />
 47             &lt;/div&gt;<br />
 48<br />
 49             &lt;div class="form-group"&gt;<br />
 50                 @Html.LabelFor(model =&gt; model.stuStudydate, new { @class = "control-label col-md-2" })<br />
 51                 &lt;div class="col-md-10"&gt;<br />
 52                     @Html.EditorFor(model =&gt; model.stuStudydate)<br />
 53                     @Html.ValidationMessageFor(model =&gt; model.stuStudydate)<br />
 54                 &lt;/div&gt;<br />
 55             &lt;/div&gt;<br />
 56<br />
 57             &lt;div class="form-group"&gt;<br />
 58                 @Html.LabelFor(model =&gt; model.stuAddress, new { @class = "control-label col-md-2" })<br />
 59                 &lt;div class="col-md-10"&gt;<br />
 60                     @Html.EditorFor(model =&gt; model.stuAddress)<br />
 61                     @Html.ValidationMessageFor(model =&gt; model.stuAddress)<br />
 62                 &lt;/div&gt;<br />
 63             &lt;/div&gt;<br />
 64<br />
 65             &lt;div class="form-group"&gt;<br />
 66                 @Html.LabelFor(model =&gt; model.stuEmail, new { @class = "control-label col-md-2" })<br />
 67                 &lt;div class="col-md-10"&gt;<br />
 68                     @Html.EditorFor(model =&gt; model.stuEmail)<br />
 69                     @Html.ValidationMessageFor(model =&gt; model.stuEmail)<br />
 70                 &lt;/div&gt;<br />
 71             &lt;/div&gt;<br />
 72<br />
 73             &lt;div class="form-group"&gt;<br />
 74                 @Html.LabelFor(model =&gt; model.stuPhone, new { @class = "control-label col-md-2" })<br />
 75                 &lt;div class="col-md-10"&gt;<br />
 76                     @Html.EditorFor(model =&gt; model.stuPhone)<br />
 77                     @Html.ValidationMessageFor(model =&gt; model.stuPhone)<br />
 78                 &lt;/div&gt;<br />
 79             &lt;/div&gt;<br />
 80<br />
 81             &lt;div class="form-group"&gt;<br />
 82                 @Html.LabelFor(model =&gt; model.stuIsDel, new { @class = "control-label col-md-2" })<br />
 83                 &lt;div class="col-md-10"&gt;<br />
 84                     @Html.EditorFor(model =&gt; model.stuIsDel)<br />
 85                     @Html.ValidationMessageFor(model =&gt; model.stuIsDel)<br />
 86                 &lt;/div&gt;<br />
 87             &lt;/div&gt;<br />
 88<br />
 89             &lt;div class="form-group"&gt;<br />
 90                 @Html.LabelFor(model =&gt; model.stuInputtime, new { @class = "control-label col-md-2" })<br />
 91                 &lt;div class="col-md-10"&gt;<br />
 92                     @Html.EditorFor(model =&gt; model.stuInputtime)<br />
 93                     @Html.ValidationMessageFor(model =&gt; model.stuInputtime)<br />
 94                 &lt;/div&gt;<br />
 95             &lt;/div&gt;<br />
 96<br />
 97             &lt;div class="form-group"&gt;<br />
 98                stuClass<br />
 99                 &lt;div class="col-md-10"&gt;<br />
100                     @Html.DropDownList("course", String.Empty)<br />
101                     @Html.ValidationMessageFor(model =&gt; model.classId)<br />
102                 &lt;/div&gt;<br />
103             &lt;/div&gt;<br />
104<br />
105             &lt;div class="form-group"&gt;<br />
106                 &lt;div class="col-md-offset-2 col-md-10"&gt;<br />
107                     &lt;input type="submit" value="Save" class="btn btn-default" /&gt;<br />
108                 &lt;/div&gt;<br />
109             &lt;/div&gt;<br />
110         &lt;/div&gt;<br />
111     }<br />
112<br />
113     &lt;div&gt;<br />
114         @Html.ActionLink("Back to List", "Index")<br />
115     &lt;/div&gt;<br />
116 &lt;/body&gt;<br />
117 &lt;/html&gt;</pre>
</div>
<p>注意，为dropdownlist使用viewdata绑定数据源。<br />右键在浏览器中查看学生列表，然后选择一条数据进行编辑，如图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/092057219594279.x-png" /></p>
<p>修改后结果</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/092058298812729.x-png" /></p>
<h3>实现信息的删除视图</h3>
<p>接下来，让我们来看一下如何实现一个用来删除数据的视图。</p>
<p>首先打开Student控制器，追加一个删除数据的方法Delete，代码如下所示。</p>
<div>
<pre class="prettyprint linenums">          public ActionResult Delete(int id)<br />
          {<br />
              var student = entity.Student.Find(id);<br />
              return View("Delete", student);

          }<br />
          [HttpPost]<br />
          public RedirectToRouteResult Delete(int id, FormCollection collection)<br />
          {

             var stu = entity.Student.Find(id);

             //因为score表中存有学生id外键，所以先删除成绩<br />
             var scores = from s in entity.Score<br />
                          where s.stuId == stu.stuId<br />
                          select s;<br />
             foreach (var item in scores)<br />
             {<br />
                 entity.Score.Remove(item);<br />
             }

             entity.Student.Remove(stu);<br />
             entity.SaveChanges();<br />
             return RedirectToAction("StudentList");<br />
         }<br />
     }</pre>
</div>
<p>这里请注意第一个没有[HttpPost]标记的Delete方法并不会将数据删除，因为如果通过GET请求而删除（或者追加、修改）删除数据的话都会打开一个安全漏洞。</p>
<p>然后在方法上右键，添加视图。<br /><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/092104575061718.x-png" /></p>
<p>Delete.cshtml代码为：</p>
<div>
<pre class="prettyprint linenums">  1 @model Wolfy.FirstMVCProject.Models.Student<br />
  2<br />
  3 @{<br />
  4     Layout = null;<br />
  5 }<br />
  6<br />
  7 &lt;!DOCTYPE html&gt;<br />
  8<br />
  9 &lt;html&gt;<br />
 10 &lt;head&gt;<br />
 11     &lt;meta name="viewport" content="width=device-width" /&gt;<br />
 12     &lt;title&gt;Delete&lt;/title&gt;<br />
 13 &lt;/head&gt;<br />
 14 &lt;body&gt;<br />
 15     &lt;h3&gt;Are you sure you want to delete this?&lt;/h3&gt;<br />
 16     &lt;div&gt;<br />
 17         &lt;h4&gt;Student&lt;/h4&gt;<br />
 18         &lt;hr /&gt;<br />
 19         &lt;dl class="dl-horizontal"&gt;<br />
 20             &lt;dt&gt;<br />
 21                 @Html.DisplayNameFor(model =&gt; model.stuName)<br />
 22             &lt;/dt&gt;<br />
 23<br />
 24             &lt;dd&gt;<br />
 25                 @Html.DisplayFor(model =&gt; model.stuName)<br />
 26             &lt;/dd&gt;<br />
 27<br />
 28             &lt;dt&gt;<br />
 29                 @Html.DisplayNameFor(model =&gt; model.stuSex)<br />
 30             &lt;/dt&gt;<br />
 31<br />
 32             &lt;dd&gt;<br />
 33                 @Html.DisplayFor(model =&gt; model.stuSex)<br />
 34             &lt;/dd&gt;<br />
 35<br />
 36             &lt;dt&gt;<br />
 37                 @Html.DisplayNameFor(model =&gt; model.stuBirthdate)<br />
 38             &lt;/dt&gt;<br />
 39<br />
 40             &lt;dd&gt;<br />
 41                 @Html.DisplayFor(model =&gt; model.stuBirthdate)<br />
 42             &lt;/dd&gt;<br />
 43<br />
 44             &lt;dt&gt;<br />
 45                 @Html.DisplayNameFor(model =&gt; model.stuStudydate)<br />
 46             &lt;/dt&gt;<br />
 47<br />
 48             &lt;dd&gt;<br />
 49                 @Html.DisplayFor(model =&gt; model.stuStudydate)<br />
 50             &lt;/dd&gt;<br />
 51<br />
 52             &lt;dt&gt;<br />
 53                 @Html.DisplayNameFor(model =&gt; model.stuAddress)<br />
 54             &lt;/dt&gt;<br />
 55<br />
 56             &lt;dd&gt;<br />
 57                 @Html.DisplayFor(model =&gt; model.stuAddress)<br />
 58             &lt;/dd&gt;<br />
 59<br />
 60             &lt;dt&gt;<br />
 61                 @Html.DisplayNameFor(model =&gt; model.stuEmail)<br />
 62             &lt;/dt&gt;<br />
 63<br />
 64             &lt;dd&gt;<br />
 65                 @Html.DisplayFor(model =&gt; model.stuEmail)<br />
 66             &lt;/dd&gt;<br />
 67<br />
 68             &lt;dt&gt;<br />
 69                 @Html.DisplayNameFor(model =&gt; model.stuPhone)<br />
 70             &lt;/dt&gt;<br />
 71<br />
 72             &lt;dd&gt;<br />
 73                 @Html.DisplayFor(model =&gt; model.stuPhone)<br />
 74             &lt;/dd&gt;<br />
 75<br />
 76             &lt;dt&gt;<br />
 77                 @Html.DisplayNameFor(model =&gt; model.stuIsDel)<br />
 78             &lt;/dt&gt;<br />
 79<br />
 80             &lt;dd&gt;<br />
 81                 @Html.DisplayFor(model =&gt; model.stuIsDel)<br />
 82             &lt;/dd&gt;<br />
 83<br />
 84             &lt;dt&gt;<br />
 85                 @Html.DisplayNameFor(model =&gt; model.stuInputtime)<br />
 86             &lt;/dt&gt;<br />
 87<br />
 88             &lt;dd&gt;<br />
 89                 @Html.DisplayFor(model =&gt; model.stuInputtime)<br />
 90             &lt;/dd&gt;<br />
 91<br />
 92             &lt;dt&gt;<br />
 93                 @Html.DisplayNameFor(model =&gt; model.Course.className)<br />
 94             &lt;/dt&gt;<br />
 95<br />
 96             &lt;dd&gt;<br />
 97                 @Html.DisplayFor(model =&gt; model.Course.className)<br />
 98             &lt;/dd&gt;<br />
 99<br />
100         &lt;/dl&gt;<br />
101<br />
102         @using (Html.BeginForm("Delete","Student",FormMethod.Post)) {<br />
103             @Html.AntiForgeryToken()<br />
104<br />
105             &lt;div class="form-actions no-color"&gt;<br />
106                 &lt;input type="submit" value="Delete" class="btn btn-default" /&gt; |<br />
107                 @Html.ActionLink("Back to List", "Index")<br />
108             &lt;/div&gt;<br />
109         }<br />
110     &lt;/div&gt;<br />
111 &lt;/body&gt;<br />
112 &lt;/html&gt;</pre>
</div>
<p>右键在浏览器中查看学生列表视图，然后选择一条学生信息，单击删除超链接。<br /><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/i/511616/201408/092135263658578.x-png" /></p>
<p>点击删除按钮，该条数据将被删除，浏览器中返回显示学生列表页面。</p>
<h3>总结</h3>
<p>最后，我们添加代码与视图模板来创建了数据的修改视图，删除视图与明细数据视图。一个简单的ASP.NET MVC5项目也算完成了。一个小demo也基本上包括增删改查的操作，接下来，将深入学习一下理论，用理论来支撑之前的实践。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8eyn1k9.html">oracle 字符串分割</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnn5gjq.html">numpy中matrix的特殊属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93njewq.html">SQL Server Reporting Service&lpar;SSRS&rpar; 第一篇  我的第一个SSRS例子</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw0ynl9.html">高性能javascript（记录三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14g10q.html">【如何快速的开发一个完整的iOS直播app】&lpar;采集篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeemzj9.html">a标签的css样式四个状态的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kkzz69.html">windows phone &lpar;14&rpar; 简单了解Ellipse元素和Rectangle元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zn50n9.html">Liniux系统下目录的权限意义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzp3ml8.html">关于WAMPserver配置httpd&period;conf无法修改根目录解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd7yx49.html">Java SVN管理工具的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj05w5q.html">PHP 查询脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kg6w59.html">SQLServer无法打开用户默认数据库 登录失败错误4064的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjogr79.html">selenium之frame</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllol60q.html">git rebase的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1dxe5q.html">CF1153F Serval and Bonus Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rj2249.html">SPEL表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4prv9.html">masstree  Seastar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rxd128.html">tst</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzgoj9.html">linux export  source</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7op05g8.html">浅谈sql中的in与not in&comma;exists与not exists的区别以及性能分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qx220ge8.html">opencv获取IP摄像头（IP-camera）实时视频流</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkv1en8.html">Android基础部分再学习---activity的状态保存</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj5wg0q.html">Weblogic集群部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv2rg2q.html">php基础设计模式 注册树模式、工厂模式、单列模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlo0xr9.html">RabbitMQ备份交换器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppm3j79.html">OpenCV&mdash;&mdash;轮廓特征描述</a>
			</li>
						<li><a href="https://www.batexi.com/a/902dp2jq.html">Linux设备驱动剖析之SPI（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v54z4q.html">文件系统的挂载&lpar;2&rpar;---挂载rootfs文件系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyv2gvdq.html">Python 编码规范&lpar;Google&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnndw6jq.html">【大数据系列】使用api修改hadoop的副本数和块大小</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
